const int SOUND_BELLOWS = 47;		//Fwooosh
const int NUM_BELLOWS_PUMPS = 2;	//The number of times to pump the bellows

extern var Firepit 739();
Bellows 431 ()
{
	var item_frame;
	var starting_frame;
	var nearby_firepits;
	var firepit;

	//Go to the bellows to operate it
	if (event == DOUBLECLICK) gotoObject(item, 1, 0, -1, Bellows, item, SCRIPTED);

	else if (event == SCRIPTED)
	{
		item_frame = UI_get_item_frame(item);

		//Forge of Virtue bellows
		if (item_frame >= 3 && item_frame <= 5) starting_frame = 3;
		//Regular bellows
		else starting_frame = 0;
	
		UI_halt_scheduled(item);	//Stop whatever animation the bellows were doing
		UI_halt_scheduled(AVATAR);	//And stop what the Avatar was doing too

		//Animate the bellows pumping
		script item
		{
			sfx SOUND_BELLOWS;
			continue;	//I actually have no idea what continue does, since it seems to animate regardless

			frame starting_frame;
			repeat (NUM_BELLOWS_PUMPS - 1)
			{
				next frame; wait 1;
				next frame; wait 1;
				previous frame; wait 1;
				previous frame; wait 1;
			};
		}

		//Animate the Avatar pumping them
		script AVATAR
		{
			face directionFromAvatar(item);
			repeat (NUM_BELLOWS_PUMPS - 1)
			{
				actor frame STAND;
				actor frame LEAN;
				wait 3;
				actor frame STAND;
			};
		}

		nearby_firepits = UI_find_nearby(item, SHAPE_FIREPIT, 4, 176);	//noooo idea what the last argument does

		//The firepit animation behaviour is now moved off to its own function, as it *really* does not belong here
		for (firepit in nearby_firepits) script firepit { call Firepit; }
	}
}