//More highly sophisticated behaviour, for sheep this time!
//Also an accusation of sheep-fucking, from our good friend Dupre.

const int SHEARED = 28;	//use the MET flag for determining if a sheep has been sheared previously
Sheep 970()
{
	UI_item_say(item, "\"Baa-aa-aa\"");
	if (event == DOUBLECLICK)
	{
		if (UI_get_random(10) < 6 && inParty(SHAMINO) && canTalk(SHAMINO))
		{
			delayedBark(SHAMINO, "\"I like sheep.\"", 6);
			if (inParty(DUPRE) && canTalk(DUPRE))
			{ 
				delayedBark(DUPRE, "\"Aye, I hath heard that about thee!\"", 16);
				delayedBark(SHAMINO, "\"Hey!\"", 26);
			}
		}
	}
}

//Organise everything for shearing, and go to the sheep
extern shearSheep 0xB21();
startShearing 0xB20(var sheep)
{
	UI_close_gumps();

	//The sheep is already sheared
	if (UI_get_item_flag(sheep, SHEARED))
	{
		randomPartySay("\"Thou hast sheared that sheep already! Give the poor thing a chance to grow it back.\"");
		return;
	}

	//make sure the shears are readied first
	if (!UI_is_readied(AVATAR, WEAPON_HAND, SHAPE_SHEARS, FRAME_ANY))
	{
		randomPartySay("\"Thou must have the shears in thy hand.\"");
		return;
	}

	//Stop the sheep from moving around before we get there.
	//Note: they will be unfrozen once they have been sheared. Unfortunately, just using a simple wait (or wait-loop) doesn't stop the GRAZE schedule from making the sheep wander off, so we actually have to paralyze them to keep them still.
	script sheep { nohalt; call freeze; }

	//Get in behind the sheep (oh, the jokes never cease)
	var sheep_offsetx = [0, -1, 1];
	var sheep_offsety = [1, 1, 1];
	gotoObject(sheep, sheep_offsetx, sheep_offsety, 0, shearSheep, sheep, SCRIPTED);

	//Hat tip to Marzo for this one - this will unfreeze the sheep if the player cancels the go-to
	UI_set_path_failure(unfreeze, sheep, SCRIPTED);
}

//Shear that sheep!
const int SOUND_SHEARING = 0;
extern finishShearing 0xB22();
shearSheep 0xB21()
{
	script AVATAR
	{
		nohalt;
		call freeze;	//paralyze the avatar so the player can't move during sequence

		face directionFromAvatar(item);
		say("\"Easy now...\"");

		repeat 6
		{
			actor frame STAND;
			actor frame SWING_2;
			sfx SOUND_SHEARING;
			actor frame SWING_3;
			wait 2;
		};
		actor frame STAND;

		call unfreeze;	//unparalyze again
	}

	script item
	{
		nohalt;
		call freeze;
		wait 20;
		say "\"Baaa!\"";
		wait 20;
		say "\"Baa-aa-aa!\"";
		call unfreeze;
		call finishShearing;	//Create the wool
	}

	//our resident sheep expert
	if (inParty(KATRINA))
	{
		var barks = [
			"\"Thou art doing it all wrong!\"",
			"\"Nay, work thy way forwards!\"",
			"\"Thou shouldst be a shepherd!\""
		];
		delayedBark(KATRINA, randomIndex(barks), 20);
	}
}

//create the wool beside the Avatar
finishShearing 0xB22()
{
	var wool;
	var target_pos;

	wool = UI_create_new_object(SHAPE_WOOL);

	UI_set_item_frame(wool, 1);	//vertical bale
	UI_set_item_flag(wool, TEMPORARY);

	target_pos = UI_get_object_position(item);	//place the new bale next to the sheep
	target_pos[X] = target_pos[X] + 1;
	target_pos[Y] = target_pos[Y] + 1;

	//Todo: stick it in the players inventory if it can't be placed here
	UI_update_last_created(target_pos);

	//Make the sheep run away after the deed is done
	UI_set_schedule_type(item, SHY);

	//This prevents us from shearing it twice
	UI_set_item_flag(item, MET);
}