//Function for trying to determine which inventory slots were which. See constants.uc for the resulting constants.

testSlots(var slotnum, var shapenum)
{
	var avatar = UI_get_avatar_ref();
	var msg;
	var found;

	avatar->say("\"Choose a shape:\"");
	shapenum	= UI_input_numeric_value(-1, 1024, 1, shapenum);

	slotnum = -1024;
	found = false;
	while (slotnum <= 1024)
	{
		if (UI_is_readied(avatar, slotnum, shapenum, FRAME_ANY))
		{
			found = true;
			break;
		}
		slotnum = slotnum + 1;
	}

	if (found) msg = "Aye, shape " + shapenum + " was found in slot " + slotnum;
	else msg = "Nay, shape " + shapenum + " could not be found";

	avatar->say("\"" + msg + ". Play again?\"");
	if (askYesNo()) testSlots(slotnum, shapenum);
}

//Performs specified behaviour when you double-click on the Mysterious Craft east of Britain.
KillWrathy 267()
{
	testSlots(0, 0);
}