/*-----------------------------
This header file defines constants for the new shapes and frames added to shapes.vga, for the Quests & Interactions patch.

Author: Alun Bestor (exult@washboardabs.net)
Last modified: 2005-04-27
-------------------------------*/

//Added to SHAPE_STONE_CHIPS
const int FRAME_SLATE	= 5;			//added for Rune of Honor quest

//Added to SHAPE_RUNE
const int FRAME_RUNE_REPLICA	= 8;	//added for Rune of Honor quest

//Added to SHAPE_KITCHEN_ITEM
const int FRAME_CHURN_2			= 16;
const int FRAME_CHURN_3			= 17;
const int FRAME_PITCHER_MILK	= 18;

//Added to SHAPE_DOUGH
const int	FRAME_DOUGH_PIE		= 3;	//flat dough + apples = pie dough (when baked in oven, this creates a pie)
const int	FRAME_DOUGH_CAKE	= 4;	//flour + egg = cake dough (when baked in oven, this creates a cake)

//Added to SHAPE_BUCKET
const int	FRAME_BUCKET_MILK	= 7;