//Live fish originally didn't do a damn thing - this makes them plop out of the water
//(using unimplemented animations from the original)

const int SOUND_FISH = 40;	//splashy sound
Fish 509 ()
{
	var frames;

	if (event == PROXIMITY)
	{
		//use unrotated (north-facing) animation set
		if (UI_get_item_frame(item) < 16) frames = [14, 13, 5, 15, 0];
		//use rotated (south-facing) animation set (slightly different order too)
		else frames = [30, 21, 29, 31, 16];

		script item
		{
			call freeze; //keep the fish from swimming during sequence (according to their schedule)

			frame frames[1];
			wait 1;
			sfx SOUND_FISH;
			frame frames[2];
			frame frames[3];
			frame frames[4];
			wait 1;
			frame frames[5];

			call unfreeze; //let it swim around again
		}
	}
}